<?php
    class modifyUser extends page{
        private $userList = Array();
        private $groupID = Array();
        private $groupName = Array();
        private $formvars = Array();
        private $error;
         
    function __construct( $smarty, $db, $action, $post, $get  )
    {
      parent::__construct( $smarty, $db, $action, $post, $get  );
      if ($this->CheckRights("modifyUser"))
      $this->logged = true;
      else $this->logged = false;
      $this->menu=new menu($this->db);
      $this->menu->GenerateMenu("");
    }
    
    //check validity of retrieved values
    function verify($formvars)
    {
        $this->error = null;
        $this->formvars = $formvars;
        
        if(strlen(trim($this->formvars['NAME'])) == 0) {
            $this->error = 'Nesprávne zadané meno';
            return false; 
        }
        if(strlen(trim($this->formvars['SURNAME'])) == 0) {
            $this->error = 'Nesprávne zadané priezvisko';
            return false; 
        }
        if(strlen(trim($this->formvars['EMAIL'])) == 0) {
            $this->error = 'Nesprávne zadaný email';
            return false; 
        }
        if(strlen(trim($this->formvars['LOCATION'])) == 0) {
            $this->error = 'Nesprávne zadané pracovisko';
            return false; 
        }    
        if(trim($this->formvars['MAKELOGIN']) === "true") {
            if(strlen(trim($this->formvars['LOGIN'])) < 6 ) {
                $this->error = 'Nesprávne zadaný login, minimálne 6 písmen';
                return false;
            } 
            if(strlen(trim($this->formvars['PASSWORD'])) < 6){
                $this->error = 'Nesprávne zadané heslo, minimálne 6 písmen';
                return false;               
            }
            if(trim($this->formvars['PASSWORD']) != trim($this->formvars['PASSCHECK'])){
                $this->error = 'Zadané heslá sa nezhodujú';
                return false;
            }    
        }
        return true;
    }
            
    function Process()
    {
      //list user details
      if ( $this->action === "details" )
      {   
        $query = "SELECT * FROM DM_Users AS users WHERE ".
                 "users.ID='".$this->getParams["id"]."';";
        $result = $this->db->QueryToRow($query);

        if ( $result != 0 )
        {
            $thesisDetails["SurName"] = $result["SURNAME"];
            $thesisDetails["Name"] = $result["NAME"];
            $thesisDetails["Login"] = $result["LOGIN"]; 
            $thesisDetails["Group"] = $result["GROUP_ID"]; 
            $thesisDetails["ID"] = $result["ID"];  
            $thesisDetails["Email"] = $result["EMAIL"];
            $thesisDetails["Location"] = $result["LOCATION"];  
            $thesisDetails["SectionID"] = $result["SECTION_ID"];  
        }
        else
        {
          $this->site->SayError(); 
        }
        
        $groupquery = "SELECT * FROM DM_Groups ORDER BY DM_Groups.ID ASC;";
        $result = $this->db->QueryToArray($groupquery);  
        
        if ( $result != 0 )
        {
          for ( $i = 0; $i < count($result); $i++ )
          {
                 $groupID[$i] = $result[$i]["ID"];
                 $groupName[$i] = $result[$i]["GROUP_NAME"];
                 if($groupID[$i] === $thesisDetails["Group"])
                 {
                     $selectedGroup = $i;
                 }                         
          }     
        }
        $sectionquery = "SELECT * FROM DM_Sections ORDER BY DM_Sections.ID ASC;";
        $result = $this->db->QueryToArray($sectionquery);  
        
        if ( $result != 0 )
        {
          for ( $i = 0; $i < count($result); $i++ )
          {
                 $sectionID[$i] = $result[$i]["ID"];
                 $sectionName[$i] = $result[$i]["SECTION_NAME"];
                 if($sectionID[$i] === $thesisDetails["SectionID"])
                 {
                     $selectedSection = $i;
                 }                         
          }     
        }
        
        $this->smarty->assign("groupID",$groupID);
        $this->smarty->assign("groupName",$groupName);
        $this->smarty->assign("sectionID",$sectionID);
        $this->smarty->assign("sectionName",$sectionName);
        $this->smarty->assign("thesisDetails",$thesisDetails);
        $this->smarty->assign("selectedGroup",$selectedGroup);  
        $this->smarty->assign("selectedSection",$selectedSection);        
        $this->smarty->assign("content","thesisDetails.tpl");
      }
      
      //get groups and section before showing addUser form
      elseif ( $this->action === "addUser" )
      {         
        $groupquery = "SELECT * FROM DM_Groups ORDER BY DM_Groups.ID ASC;";
        $result = $this->db->QueryToArray($groupquery);  
        
        if ( $result != 0 )
        {
          for ( $i = 0; $i < count($result); $i++ )
          {
                 $groupID[$i] = $result[$i]["ID"];
                 $groupName[$i] = $result[$i]["GROUP_NAME"];                       
          }     
        }
        $sectionquery = "SELECT * FROM DM_Sections ORDER BY DM_Sections.ID ASC;";
        $result = $this->db->QueryToArray($sectionquery);  
        
        if ( $result != 0 )
        {
          for ( $i = 0; $i < count($result); $i++ )
          {
                 $sectionID[$i] = $result[$i]["ID"];
                 $sectionName[$i] = $result[$i]["SECTION_NAME"];                       
          }     
        }
        
        $this->smarty->assign("groupID",$groupID);
        $this->smarty->assign("groupName",$groupName);
        $this->smarty->assign("sectionID",$sectionID);
        $this->smarty->assign("sectionName",$sectionName);        
        $this->smarty->assign("content","addUser.tpl");
      }
      
      // list users
      else if ( $this->action === "listUsers" )
      {
          $groupquery = "SELECT * FROM DM_Groups;";
          $groups = $this->db->QueryToArray($groupquery);
          $sectionquery = "SELECT * FROM DM_Sections;";
          $sections = $this->db->QueryToArray($sectionquery);
          
          $query = "SELECT * FROM DM_Users ". 
          "ORDER BY DM_Users.".$this->getParams["order"].";"; 
                     
        $result = $this->db->QueryToArray($query);
        if ( $result != 0 )
        {
          for ( $i = 0; $i < count($result); $i++ )
          {
                 $userList[$i]["SurName"] = $result[$i]["SURNAME"];
                 $userList[$i]["Name"] = $result[$i]["NAME"];
                 $userList[$i]["Login"] = $result[$i]["LOGIN"]; 
                 $userList[$i]["Group"] = $result[$i]["GROUP_ID"]; 
                 $userList[$i]["SectionID"] = $result[$i]["SECTION_ID"];  
                 $userList[$i]["ID"] = $result[$i]["ID"];
                     
                 foreach($groups as $key)
                 {
                     if ($key["ID"] === $userList[$i]["Group"] )
                        {
                           $userList[$i]["Group"] = $key["GROUP_NAME"]; 
                        }           
                 }  
                 
                 foreach($sections as $key)
                 {
                     if ($key["ID"] === $userList[$i]["SectionID"] )
                        {
                           $userList[$i]["SectionID"] = $key["SECTION_NAME"]; 
                        }           
                 }   
          }
        }  
        
        $this->smarty->assign("userList",$userList);
        $this->smarty->assign("content","listUsers.tpl"); 
      }
      
      //delete user
      else if ( $this->action === "delete" )
      {
           $query = "DELETE FROM DM_Users ". 
          "WHERE DM_Users.ID='".$this->getParams["id"]."' LIMIT 1;"; 
                     
        $result = $this->db->Query($query);
        $actionResult = "Užívateľ bol zmazaný";
           
        $this->smarty->assign("userList",$userList);
        $this->smarty->assign("actionResult",$actionResult);  
        $this->smarty->assign("content","modifyUserMain.tpl"); 
      }
      
      //update user details
      else if ( $this->action === "update" )
      { 
          
          $query = "UPDATE DM_Users ". 
          "SET DM_Users.NAME = '".$this->postParams["NAME"]."', ".                           
          "DM_Users.SURNAME = '".$this->postParams["SURNAME"]."', ".
          "DM_Users.LOGIN = '".$this->postParams["LOGIN"]."', ". 
          "DM_Users.GROUP_ID = '".$this->postParams["GROUP_ID"]."', ".  
          "DM_Users.EMAIL = '".$this->postParams["EMAIL"]."', ".  
          "DM_Users.SECTION_ID = '".$this->postParams["SECTION_ID"]."', ".   
          "DM_Users.LOCATION = '".$this->postParams["LOCATION"]."' ";
          if ($this->postParams["PASSCHECK"] === "true")
          {
              $query .= ", DM_Users.PASSWORD = MD5('".$this->postParams["PASSWORD"]."') "; 
          }
               
          $query .= "WHERE DM_Users.ID='".$this->getParams["ID"]."';"; 
                     
        $result = $this->db->Query($query);
        $actionResult = "Užívateľove údaje boli zmenené";
           
        $this->smarty->assign("userList",$userList);
        $this->smarty->assign("actionResult",$actionResult);  
        $this->smarty->assign("content","modifyUserMain.tpl"); 
      }
      //add user to DB and send notification email
       else if ( $this->action === "addUserToDB" )
      {
          if ($this->verify($_POST))
          {
          
          
          $dbQuery["NAME"] = $this->postParams["NAME"];
          $dbQuery["SURNAME"] = $this->postParams["SURNAME"];
          $dbQuery["GROUP_ID"] = $this->postParams["GROUP_ID"]; 
          $dbQuery["EMAIL"] = $this->postParams["EMAIL"]; 
          $dbQuery["SECTION_ID"] = $this->postParams["SECTION_ID"];  
          $dbQuery["LOCATION"] = $this->postParams["LOCATION"];      
          
          if ($this->postParams["MAKELOGIN"] === "true")
          {  
             if ($this->postParams["PASSWORD"] === $this->postParams["PASSCHECK"])
             { 
              $dbQuery["LOGIN"] = $this->postParams["LOGIN"];
              $query = "INSERT INTO DM_Users (".implode(",", array_keys($dbQuery)).",PASSWORD) VALUES ('".implode("','", array_values($dbQuery))."',MD5('".$this->postParams["PASSWORD"]."'))";    
             } else $this->smarty->assign("error", "Zadané heslá sa nezhodujú.");
          } else $query = "INSERT INTO DM_Users (".implode(",", array_keys($dbQuery)).") VALUES ('".implode("','", array_values($dbQuery))."')"; 
                     
        $result = $this->db->Query($query);
        $actionResult = "Užívateľove údaje boli zmenené";
        
        $sendmail = new sendEmail($this->smarty, $this->db, $this->action, $_POST, $_GET); 
        $mailparams = Array();
        $mailparams["%LOGIN%"] = $dbQuery["LOGIN"];
        $mailparams["%PASSWORD%"] = $this->postParams["PASSWORD"];
        $sendmail->simpleSend($dbQuery["EMAIL"],"", "1", $mailparams,"");
           
        $this->smarty->assign("userList",$userList);
        $this->smarty->assign("actionResult",$actionResult);  
        $this->smarty->assign("content","modifyUserMain.tpl"); 
        }
        else {
                $this->smarty->assign("post",$this->formvars); 
                $this->smarty->assign("error",$this->error); 
                $this->smarty->assign("content","addUser.tpl");   
                $this->action = "addUser";     
                $this->Process();
             }   
      }
      else $this->smarty->assign("content","modifyUserMain.tpl"); 
      return true;
    }
    
    function Draw()
    {
      $this->smarty->assign("title", "Modifikácia užívateľov");
      parent::Draw();

    }
    }
?>
